SystemOrganization addCategory: #ConfigurationOfSpy!

Object subclass: #ConfigurationOfSpy
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfSpy'!

!ConfigurationOfSpy class methodsFor: 'development support' stamp: 'AlexandreBergel 1/12/2015 12:27'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfSpy class methodsFor: 'private' stamp: 'AlexandreBergel 1/12/2015 12:27'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfSpy class methodsFor: 'private' stamp: 'AlexandreBergel 1/12/2015 12:27'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfSpy class methodsFor: 'private' stamp: 'AlexandreBergel 1/12/2015 12:27'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfSpy class methodsFor: 'metacello tool support' stamp: 'AlexandreBergel 1/12/2015 12:27'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSpy class methodsFor: 'loading' stamp: 'AlexandreBergel 1/12/2015 12:27'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfSpy class methodsFor: 'loading' stamp: 'AlexandreBergel 1/12/2015 12:27'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfSpy class methodsFor: 'loading' stamp: 'AlexandreBergel 1/12/2015 12:27'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfSpy class methodsFor: 'accessing' stamp: 'AlexandreBergel 1/12/2015 12:27'!
project

	^self new project! !

!ConfigurationOfSpy class methodsFor: 'development support' stamp: 'AlexandreBergel 1/12/2015 12:27'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfSpy methodsFor: 'baselines' stamp: 'AlexandreBergel 1/12/2015 12:34'!
baseline10: spec
	"Baselines are used by convention in Metacello and essentially are nothing else than normal versions.
	Name the baseline after the first version it was introduced.
	In this case 1.0-baseline was introduced the first time with the 1.0 version defined in the #version10 method.
	Metacello only uses the following tag to figure out the name of this baseline:"
	<version: '1.0-baseline'>

	"Using #common makes this dependency declaration available for all Smalltalks.
	If you need more fine-grained control you can add several #for:do: sections for other releases."
	spec for: #common do: [	
		spec blessing: #baseline.
		"specify the default repository for your project's packages"
		spec repository: 'http://www.smalltalkhub.com/mc/ObjectProfile/S2py/main'.
	
		"specify the dependencies between packages and projects"
		spec
			"a package without dependencies:"
			package: 'S2py' with: [ 
				"Specfiy dependencies using the #requires: directive, you can refer to any name here, in this case to an external project"
				spec requires: #('Roassal2') ];
			package: 'GT-Spy2-Inspector';
			package: 'GT-Spy2-Debugger'.
			
		"using groups certain packages and projects can be loaded conditionally"
		spec 
			"load the tests by default"
			group: 'default' with: #('S2py' 'Roassal2' 'GT-Spy2-Inspector' 'GT-Spy2-Debugger');
			group: 'test'    with: #('S2py' 'Roassal2' 'GT-Spy2-Inspector' 'GT-Spy2-Debugger');
			group: 'core'    with: #('S2py' 'Roassal2' 'GT-Spy2-Inspector' 'GT-Spy2-Debugger').
			
		spec project: 'Roassal2' with: [
				spec
					className: 'ConfigurationOfRoassal2';
					file: 'ConfigurationOfRoassal2';
					version: #development;
					repository: 'http://www.smalltalkhub.com/mc/ObjectProfile/Roassal2/main' ].
]! !

!ConfigurationOfSpy methodsFor: 'accessing' stamp: 'AlexandreBergel 1/12/2015 12:27'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfSpy methodsFor: 'symbolic versions' stamp: 'AlexandreBergel 1/12/2015 12:35'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0-baseline'.
! !

!ConfigurationOfSpy methodsFor: 'accessing' stamp: 'AlexandreBergel 1/12/2015 12:27'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfSpy methodsFor: 'symbolic versions' stamp: 'AlexandreBergel 1/12/2015 12:40'!
stable: spec
	<symbolicVersion: #'common'>

	spec for: #'common' version: '1.0-baseline'.
! !

!ConfigurationOfSpy methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/12/2015 12:39'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.0'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '1/12/2015 12:38'.
		spec 
			project: 'Roassal2' with: #stable;
			project: 'S2py' with: 'S2py-AlejandroInfante.184';
			project: 'GT-Spy2-Debugger' with: 'GT-Spy2-Debugger-AndreiChis.1';
			project: 'GT-Spy2-Inspector' with: 'GT-Spy2-Inspector-AlexandreBergel.8' ]! !
